package com.syntevo.plugin.jira.commit.workflow;

import com.syntevo.plugin.jira.transport.*;

/**
 * @author syntevo GmbH
 */
class JiraResolvePacket {

	// Fields =================================================================

	private final JiraConnection connection;
	private final String issueKey;
	private final JiraVersion fixVersion;

	// Setup ==================================================================

	public JiraResolvePacket(JiraConnection connection, String issueKey, JiraVersion fixVersion) {
		this.connection = connection;
		this.issueKey = issueKey;
		this.fixVersion = fixVersion;
	}

	// Accessing ==============================================================

	public JiraConnection getConnection() {
		return connection;
	}

	public String getIssueKey() {
		return issueKey;
	}

	public JiraVersion getFixVersion() {
		return fixVersion;
	}
}