package com.syntevo.plugin.jira.transport;

import java.io.*;

/**
 * @author syntevo GmbH
 */
class JiraDebugLoggingInputStream extends InputStream {

	// Fields =================================================================

	private InputStream in;
	private OutputStream log;

	// Setup ==================================================================

	public JiraDebugLoggingInputStream(InputStream in, OutputStream logStream) {
		this.in = in;
		this.log = logStream;
	}

	// Implemented ============================================================

	public int read() throws IOException {
		int read;
		try {
			read = in.read();
			try {
				if (read >= 0) {
					log.write(read & 0xFF);
				}
			}
			catch (IOException e) {
			}
		}
		catch (IOException e) {
			throw e;
		}
		return read;
	}

	public long skip(long n) throws IOException {
		return in.skip(n);
	}

	public void close() throws IOException {
		try {
			in.close();
		}
		catch (IOException e) {
			throw e;
		}
		finally {
			try {
				log.close();
			}
			catch (IOException e) {
			}
		}
	}

	public int read(byte[] b, int off, int len) throws IOException {
		int read;
		try {
			read = in.read(b, off, len);
			if (read > 0) {
				try {
					log.write(b, off, read);
				}
				catch (IOException e) {
				}
			}
		}
		catch (IOException e) {
			throw e;
		}
		return read;
	}

	// Accessing ==============================================================

	public void flushBuffer() {
		try {
			log.flush();
		}
		catch (IOException e) {
		}
	}
}